use std::collections::HashSet;
use std::error;
use std::fs::File;
use std::io::prelude::*;

fn main() -> Result<(), Box<dyn error::Error>> {
	let mut f = File::open("input.txt")?;

	let mut buf = [0; 32];
	let mut pos = 0;
	let mut found = false;
	let mut n = f.read(&mut buf[3..])?;
	while n > 0 {
		for i in 4..(4 + n) {
			pos += 1;
			// println!("{}", std::str::from_utf8(&buf[(i - 4)..i]).unwrap());
			// skip if we read uninitialized data from first run
			if buf[i - 4] == 0 {
				continue;
			}
			let set: HashSet<&u8> = HashSet::from_iter(&buf[(i - 4)..i]);
			if set.len() == 4 {
				found = true;
				break;
			}
		}
		if found {
			break;
		}
		for i in 0..3 {
			buf[i] = buf[29 + i];
		}
		n = f.read(&mut buf[3..])?;
	}
    println!("Found 4 different chars at position {}", pos);
    Ok(())
}
